<?php

/*********************************************************************

 スパム対策プラグイン Ver 2.01 (2009/02/04)

 @Link http://www.php-labo.net/
 @Copyright(C) 2007-2009 PHP Labo
 @Author Knight <info at php-labo dot net>

*********************************************************************/

/* コメントの受信内容をチェック */
function plugin_spam_filter_comment()
{
	global $configs;

	if ($configs['spam_filter']['deny_host']) {
		foreach (explode(',', $configs['spam_filter']['deny_host']) as $host) {
			if (preg_match("/$host/", gethostbyaddr($_SERVER['REMOTE_ADDR']))) {
				error('不正なアクセスです。');
			}
		}
	}
	if ($configs['spam_filter']['deny_word_comment']) {
		foreach (explode(',', $configs['spam_filter']['deny_word_comment']) as $word) {
			if (preg_match("/$word/", $_POST['text'])) {
				error('「' . $word . '」は投稿禁止ワードに設定されています。');
			}
		}
	}
	if ($configs['spam_filter']['need_word_comment']) {
		$flag = false;
		foreach (explode(',', $configs['spam_filter']['need_word_comment']) as $word) {
			if (preg_match("/$word/", $_POST['text'])) {
				$flag = true;
			}
		}
		if (!$flag) {
			error('投稿必須ワードが含まれていません。');
		}
	}
	if ($configs['spam_filter']['need_japanese_comment'] and mb_detect_encoding($_POST['text']) != 'UTF-8') {
		error('日本語を含まないコメントは投稿できません。');
	}
	if (substr_count($_POST['text'], 'http://') >= $configs['spam_filter']['max_url_comment']) {
		error('本文にURLを' . $configs['spam_filter']['max_url_comment'] . '個以上書くことはできません。');
	}

	return;
}

/* トラックバックの受信内容をチェック */
function plugin_spam_filter_trackback()
{
	global $configs;

	if ($configs['spam_filter']['deny_url_trackback']) {
		foreach (explode(',', $configs['spam_filter']['deny_url_trackback']) as $url) {
			if (preg_match("/$url/", $_POST['url'])) {
				tb_error('Forbidden URL (url)');
			}
		}
	}
	if ($configs['spam_filter']['deny_word_trackback']) {
		foreach (explode(',', $configs['spam_filter']['deny_word_trackback']) as $word) {
			if (preg_match("/$word/", $_POST['excerpt'])) {
				tb_error($word . ' is NG Word (excerpt)');
			}
		}
	}
	if ($configs['spam_filter']['need_word_trackback']) {
		$flag = false;
		foreach (explode(',', $configs['spam_filter']['need_word_trackback']) as $word) {
			if (preg_match("/$word/", $_POST['excerpt'])) {
				$flag = true;
			}
		}
		if (!$flag) {
			tb_error('Required Word No Exist (excerpt)');
		}
	}
	if ($configs['spam_filter']['need_japanese_trackback'] and mb_detect_encoding($_POST['excerpt']) != 'UTF-8') {
		tb_error('No Japanese (excerpt)');
	}
	if ($configs['spam_filter']['need_link_trackback']) {
		$info = parse_url($_POST['url']);

		$request  = "GET " . $info['path'] . " HTTP/1.0\r\n";
		$request .= "Host: " . $info['host'] . "\r\n";
		$request .= "User-Agent: PHP Blog\r\n";
		$request .= "\r\n";

		$data = '';

		if ($sock = fsockopen($info['host'], 80)) {
			fputs($sock, $request);
			while (!feof($sock)) {
				$data .= fgets($sock);
			}
			fclose($sock);
		} else {
			tb_error('Socket error');
		}

		if (!preg_match('/' . preg_quote(HTTP_PATH, '/') . '/', $data)) {
			tb_error('URL of This Site is Not Found in ' . $_POST['url']);
		}
	}

	return;
}

/* モードに応じた処理を実行 */
if ($_REQUEST['mode'] == 'comment') {
	plugin_spam_filter_comment();
} elseif ($_REQUEST['mode'] == 'trackback') {
	plugin_spam_filter_trackback();
}

?>
